#!/bin/sh

#vars

GAMES_LIST="games.list"
OUTPUT_UNIF="multirom.unf"
OUTPUT_BIN="multirom.bin"
MENU_IMAGE="menu.png"
MAX_SIZE="64"
SORT_GAMES="FALSE"
CONVERTER="tools/TilesConverter.exe"
COMBINER="tools/CoolgirlCombiner.exe"
NESASM="tools/nesasm"
OFFSETS_FILE="offsets.xml"
REPORT_FILE="report.txt"

#remove old files

if [ -f menu.nes ];
    then    
   rm -f menu.nes
fi

if [ -f menu_pattern0.dat ];
    then    
   rm -f menu_pattern0.dat
fi

if [ -f menu_nametable0.dat ];
    then    
   rm -f menu_nametable0.dat
fi

if [ -f menu_palette0.dat ];
    then    
   rm -f menu_palette0.dat
fi

if [ -f menu_palette1.dat ];
    then    
   rm -f menu_palette1.dat
fi

if [ -f menu_pattern1.dat ];
    then    
   rm -f menu_pattern1.dat
fi

if [ -f games.asm ];
    then    
   rm -f games.asm
fi

if [ -f $OFFSETS_FILE ];
    then    
   rm -f $OFFSETS_FILE
fi

if [ -f $REPORT_FILE ];
    then    
   rm -f $REPORT_FILE
fi

if [ -f $OUTPUT_UNIF ];
    then    
   rm -f $OUTPUT_UNIF
fi

if [ -f $OUTPUT_BIN ];
    then    
   rm -f $OUTPUT_BIN
fi


if
   [ "$SORT_GAMES" != "TRUE" ] ;
    then
        NOSORTP="--nosort" 
fi

# build rom

wine $CONVERTER $MENU_IMAGE menu_pattern0.dat menu_nametable0.dat menu_palette0.dat
wine $CONVERTER menu_sprites.png menu_pattern1.dat menu_nametable1.dat menu_palette1.dat
wine $COMBINER prepare --games $GAMES_LIST --asm games.asm --maxsize $MAX_SIZE --offsets $OFFSETS_FILE --report $REPORT_FILE $NOSORTP
wine $NESASM menu.asm
wine $COMBINER combine --loader menu.nes --offsets $OFFSETS_FILE --unif $OUTPUT_UNIF --bin $OUTPUT_BIN

if [ -f $OUTPUT_UNIF ];
    then
   echo "Seems like everything is fine! $OUTPUT_UNIF created."
fi


